=== modified file 'testweave.py'
--- testweave.py	2005-06-28 13:38:55 +0000
+++ testweave.py	2005-06-28 13:55:37 +0000
@@ -177,6 +177,37 @@
 
 
 
+class DeleteLines(TestBase):
+    """Deletion of lines from existing text.
+
+    Try various texts all based on a common ancestor."""
+    def runTest(self):
+        k = Weave()
+
+        base_text = ['one', 'two', 'three', 'four']
+
+        k.add([], base_text)
+        
+        texts = [['one', 'two', 'three'],
+                 ['two', 'three', 'four'],
+                 ['one', 'four'],
+                 ['one', 'two', 'three', 'four'],
+                 ]
+
+        for t in texts:
+            ver = k.add([0], t)
+
+        from pprint import pformat
+        self.log('final weave:')
+        self.log('k._l=' + pformat(k._l))
+
+        for i in range(len(texts)):
+            self.assertEqual(k.get(i+1),
+                             texts[i])
+            
+
+
+
 class SuicideDelete(TestBase):
     """Invalid weave which tries to add and delete simultaneously."""
     def runTest(self):
@@ -362,7 +393,7 @@
                          
 
 
-class DeleteLines(TestBase):
+class DeleteLines2(TestBase):
     """Test recording revisions that delete lines.
 
     This relies on the weave having a way to represent lines knocked
@@ -377,8 +408,6 @@
 
         self.assertEqual(len(k.get(0)), 4)
 
-        return ################################## SKIPPED
-
         k.add([0], ["line the first",
                    "fine"])
 
@@ -386,6 +415,10 @@
                          ["line the first",
                           "fine"])
 
+        self.assertEqual(k.annotate(1),
+                         [(0, "line the first"),
+                          (0, "fine")])
+
 
 
 class IncludeVersions(TestBase):

=== modified file 'weave.py'
--- weave.py	2005-06-28 13:38:55 +0000
+++ weave.py	2005-06-28 13:55:37 +0000
@@ -149,16 +149,21 @@
                 assert 0 <= i1
                 assert i1 <= i2
                 assert i2 <= len(self._l)
-                
+
+                # the deletion and insertion are handled separately.
+                # first delete the region.
                 if i1 != i2:
-                    raise NotImplementedError("can't handle replacing weave [%d:%d] yet"
-                                              % (i1, i2))
+                    self._l.insert(i1+offset, ('[', idx))
+                    self._l.insert(i2+offset+1, (']', idx))
+                    offset += 2
+                    # is this OK???
 
-                i = i1 + offset
-                self._l[i:i] = [('{', idx)] \
-                               + newlines \
-                               + [('}', idx)]
-                offset += 2 + len(newlines)
+                if newlines:
+                    i = i1 + offset
+                    self._l[i:i] = [('{', idx)] \
+                                   + newlines \
+                                   + [('}', idx)]
+                    offset += 2 + len(newlines)
 
             self._v.append(VerInfo(parents))
         else:

